
/*
Copyright 2007-2009 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

const CLASS_ID = Components.ID("{46d09504-6a0b-40c8-8ce8-d07cf370d25e}");
const CLASS_NAME = "Yet Another Remove It Permanently";
const CONTRACT_ID = "@yarip.mozdev.org;1";

const prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

const TYPE_DOCUMENT = Components.interfaces.nsIContentPolicy.TYPE_DOCUMENT;
const DOCUMENT_NODE = Components.interfaces.nsIDOMNode.DOCUMENT_NODE;
const ACCEPT = Components.interfaces.nsIContentPolicy.ACCEPT;
const REJECT_SERVER = Components.interfaces.nsIContentPolicy.REJECT_SERVER;

var yarip = {
    STYLE: "extensions/yarip@mozdev.org/style.css",
    XPATH: "yarip.xml",

    PAGE_MODE: 0,
    FQDN_MODE: 1,
    SLD_MODE: 2,
    USER_MODE: 3,

    TYPE_WHITELIST: 0,
    TYPE_BLACKLIST: 1,
    TYPE_STYLE: 2,

    NO_CHANGE: 0,
    MINOR_CHANGE: 1,
    ESSENTIAL_CHANGE: 2,

    BOOLEAN: 0,
    INTEGER: 1,
    STRING: 2,
    RESET: 3,

    INCREMENT_NOT_FOUND: 0,
    INCREMENT_IGNORED: 1,
    INCREMENT_FOUND: 2,

    FIRSTRUN: "extensions.yarip.firstrun",
    VERSION: "extensions.yarip.version",
    ENABLED_ROOT: "extensions.yarip.enabled.",
    ENABLED: "extensions.yarip.enabled.value",
    FLICKER_ROOT: "extensions.yarip.noFlicker.",
    FLICKER: "extensions.yarip.noFlicker.value",
    MODE_ROOT: "extensions.yarip.mode.",
    MODE: "extensions.yarip.mode.value",
//    DEEP_ROOT: "extensions.yarip.deep.",
//    DEEP: "extensions.yarip.deep.value",
//    RELOAD_ROOT: "extensions.yarip.reload.",
//    RELOAD: "extensions.yarip.reload.value",
    INDEX_ROOT: "extensions.yarip.alwaysUseIndex.",
    INDEX: "extensions.yarip.alwaysUseIndex.value",
    ELEMENTS_ROOT: "extensions.yarip.elementsInContext.",
    ELEMENTS: "extensions.yarip.elementsInContext.value",
    PURGE_ROOT: "extensions.yarip.purgeInnerHTML.",
    PURGE: "extensions.yarip.purgeInnerHTML.value",
//    SAVE_ROOT: "extensions.yarip.save.",
//    SAVE: "extensions.yarip.save.value",
    VALUE: "value",

    CHARSET: "UTF-8",
//    CHARACTERS: {
//        "&#38;": /&/g,
//        "&#34;": /\"/g,
//        "&#60;": /</g,
//        "&#62;": />/g
//    },

    firstLoad: true,
    enabled: null,
    noFlicker: null,
    mode: null,
//    deep: null,

//    monitorDialog: null,
    monitorDialog: new Array(),
    pageDialog: null,

    alwaysUseIndex: false,
    elementsInContext: 4,
    changeType: 0,
    purgeInnerHTML: false,

    address: null,
    map: null,
    undoObj: {}
//    logFile: null
}

//yarip.OFFICIAL_SCHEME = "(aaas|aaa|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|gopher|go|h323|https|http|iax2|icap|imap|im|info|ipp|iris\\.beep|iris\\.lwz|iris\\.xpcs|iris\\.xpc|iris|ldap|mailserver|mailto|mid|modem|msrps|msrp|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sips|sip|snmp|soap\\.beeps|soap\\.beep|tag|telnet|tel|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc\\.beeps|xmlrpc\\.beep|xmpp|z39\\.50r|z39\\.50s)";
//yarip.UNOFFICIAL_SCHEME = "(about|addbook|afp|aim|applescript|bcp|bk|btspp|callto|castanet|cdv|chrome|chttp|cvs|daytime|device|doi|ed2k|eid|enp|feed|finger|fish|freenet|gg|gizmoproject|gsiftp|gsm-sms|h324|hdl|hnews|httpsy|iioploc|ilu|IOR|ircs|irc|itms|jar|javascript|jdbc|klik|kn|lastfm|ldaps|lifn|livescript|lrq|magnet|mailbox|man|md5|mms|mocha|moz-abmdbdirectory|msnim|myim|notes|nsfw|oai|pcast|phone|php|pop3|printer|psyc|pyimp|rdar|res|rsync|rvp|rwhois|rx|sdp|secondlife|sftp|skype|smb|sms|snews|soap\\.udp|soldat|ssh|steam|SubEthaEdit|svn\\+ssh|svn|t120|tann|tcp|telephone|txmt|uddi|unreal|ut2004|uuid|videotex|view-source|wcap|webcal|whodp|whois\\+\\+|whois|wpn|wtai|xeerkat|xfire|ymsgr)";
//yarip.SCHEME = "(" + yarip.OFFICIAL_SCHEME + "|" + yarip.UNOFFICIAL_SCHEME + "):";
yarip.IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
yarip.IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
yarip.IP = "(" + yarip.IPV4ADDRESS + "|" + yarip.IP_LITERAL + ")";
yarip.AUTHORITY = "([a-z\\d]([\\w-.~!$&*+,=:]|%[a-f\\d]{2})*@)?";
yarip.REG_NAME = "([a-z\\d]([\\w-~!$&*+,=@]|%[a-f\\d]{2})+\\.)+";
yarip.SIMPLE = "([a-z\\d]([\\w-~!$&'()*+,;=]|%[a-f\\d]{2})+)";
//yarip.ULD = "[a-z\\d]([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})+\\.";
yarip.SLD = yarip.SIMPLE + "\\.";
yarip.TLD = "(ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
yarip.PORT = "(:\\d+)?";
//yarip.HIER_PART = "(((\\/\\/)?((([\\w-.~!$&'()*+,;=:]|%[a-f\\d]{2})*@)?(" + yarip.IP + "|([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})*)" + yarip.PORT + "))([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)";
yarip.PATH = "([;/]([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)?";
yarip.QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";

//yarip.URI1 = "(" + yarip.SCHEME + yarip.HIER_PART + yarip.QUERY_FRAGMENT + ")";
yarip.URI2 = "(" + yarip.AUTHORITY + "(" + yarip.IP + "|(" + yarip.REG_NAME + yarip.TLD + "\\b))" + yarip.PORT + yarip.PATH + yarip.QUERY_FRAGMENT + ")";

//yarip.uriRegExp = new RegExp("^(" + yarip.URI1 + "|" + yarip.URI2 + ")$", "i");
yarip.noSchemeRegExp = new RegExp("^" + yarip.URI2 + "$", "i");
//yarip.simpleRegExp = new RegExp("^" + yarip.SIMPLE + "\\b" + yarip.PORT + "$", "i");
//yarip.domainRegExp = new RegExp("^(" + yarip.IP + "|(" + yarip.ULD + yarip.TLD + "\\b))" + yarip.PORT + "$", "i");
//yarip.findDomainRegExp = new RegExp("\\b(" + yarip.IP + "|(" + yarip.ULD + yarip.TLD + ")|" + yarip.SIMPLE + ")\\b" + yarip.PORT, "i");
yarip.findSldRegExp = new RegExp("\\b(" + yarip.IP + "|(" + yarip.SLD + yarip.TLD + ")|" + yarip.SIMPLE + ")\\b" + yarip.PORT + "$", "i");

yarip.outlineRegExp = /^outline-color:\ rgb\((0|153),\ 0,\ (0|153)\);\ outline-style:\ solid;\ outline-width:\ 3px;$/;
yarip.endOutlineRegExp = /outline-color:\ rgb\((0|153),\ 0,\ (0|153)\);\ outline-style:\ solid;\ outline-width:\ 3px;$/;

yarip.toggleEnabled = function(enabled)
{
    if (enabled == this.enabled) return false;

    if (enabled != true && enabled != false) enabled = !this.enabled;
    this.enabled = enabled;
    this.save();

    if (enabled) this.toggleNoFlicker(this.getValue(this.FLICKER, false, this.BOOLEAN), null, true);
    else this.toggleNoFlicker(false, true, true);

    this.setValue(this.ENABLED, enabled, this.BOOLEAN); // notify
    return true;
}

yarip.toggleNoFlicker = function(noFlicker, dontNotify, force)
{
    if (noFlicker == this.noFlicker && !force) return false;

//    if (noFlicker != true && noFlicker != false) noFlicker = !this.noFlicker;
    if (noFlicker != true && noFlicker != false) noFlicker = !this.getValue(this.FLICKER, false, this.BOOLEAN);
    this.noFlicker = noFlicker;

    this.toggleStyle();
    this.injectCSS("chrome://yarip/content/noflicker.css", this.noFlicker && this.enabled);
    if (!dontNotify) this.setValue(this.FLICKER, this.noFlicker, this.BOOLEAN); // notify
    return true;
}

yarip.toggleStyle = function()
{
    var file = this.getFile(this.STYLE);
    if (file) this.injectCSS("file://" + file.path, this.noFlicker && this.enabled);
}

yarip.setMode = function(mode)
{
    var mode = Number(mode);
    if (mode != this.USER_MODE && (/*mode == this.mode ||*/ typeof mode != "number" || mode + "" == "NaN")) return false;
    this.mode = mode;
    this.setValue(this.MODE, mode, this.INTEGER); // notify
    return true;
}

//yarip.toggleDeep = function(deep)
//{
//    if (deep == this.deep) return false;

//    if (deep != true && deep != false) deep = !this.deep;
//    this.deep = deep;

//    this.setValue(this.DEEP, deep, this.BOOLEAN); // notify
//    return true;
//}

yarip.setAlwaysUseIndex = function(value)
{
    if (value == true || value == false) this.alwaysUseIndex = value;
}

yarip.setElementsInContext = function(value)
{
    var value = Number(value);
    if (typeof value != "number" || value + "" == "NaN") return;
    if (value > 0 && value <= 20) this.elementsInContext = value;
}

yarip.setPurgeInnerHTML = function(value)
{
    if (value == true || value == false) this.purgeInnerHTML = value;
}

yarip.setChangeType = function(type, force)
{
    if (!this.changeType || type > this.changeType || force) this.changeType = type;
}

yarip.getAddress = function(location, mode)
{
    var mode = Number(mode);
    if (typeof mode != "number" || mode + "" == "NaN") mode = this.mode;
    if (!location) return null;
    if (!/^https?:$/.test(location.protocol)) return null;

    var address = null;
    try
    {
        switch (mode)
        {
            case this.PAGE_MODE:
                this.address = null;
//                address = location.href;
                address = location.protocol + "//" + location.host + location.pathname;
                break;

            case this.FQDN_MODE:
                this.address = null;
                address = location.host;
                break;

            case this.SLD_MODE:
                this.address = null;
                var sld = location.host.match(this.findSldRegExp);
                if (sld) address = sld[0];
                break;

            case this.USER_MODE:
                if (
                    this.address
                    && new RegExp(this.address.replace(/(\W)/g, "\\$1")).test(location.href)
                ) address = this.address;
                break;
        }
        if (address == "") return null;
    }
    catch (e){}
    return address;
}

//yarip.getAddressArray = function(doc, follow)
yarip.getAddressArray = function(reduceDomain, follow)
{
//    if (!doc) return null;
    if (!reduceDomain) return null;

    var aAddress = {}
    var tmpDomain = null;
//    var reduceDomain = this.getAddress(doc.location, this.PAGE_MODE);
//    var reduceDomain = doc.location.protocol + "//" + doc.location.host + doc.location.pathname;

    while (reduceDomain != tmpDomain)
    {
        var reducePath = reduceDomain;
        var tmpPath = null;

        while (reducePath != tmpPath)
        {
            if (this.map.obj[reducePath]) aAddress[reducePath] = true;
            tmpPath = reducePath;
            reducePath = reducePath.replace(/(\/|[^/]*)$/, "");
//            reducePath = reducePath.replace(/([/?&]|[^/?&]*)$/, "");
        }

        tmpDomain = reduceDomain;
        reduceDomain = reduceDomain.replace(/^([^:]+:\/\/|[^.]+\.)/, "");
//        reduceDomain = reduceDomain.replace(/(^([^:]+:\/+|[^.]+\.))|:\d+$/, "");
    }

    if (follow) this.getExtensionAddressArray(aAddress, true);

    return aAddress;
}

yarip.getExtensionAddressArray = function(aAddress, append)
{
//    if (!aAddress) return null;

    if (append) for (var a in aAddress) this.getRecursiveAddressArray(a, aAddress);
    else
    {
        var aTmp = {}
        for (var a in aAddress) this.getRecursiveAddressArray(a, aTmp);
        return aTmp;
    }

    return null;
}

yarip.getRecursiveAddressArray = function(address, aAddress)
{
    var extensions = this.map.obj[address].extension.obj;
    for (var id in extensions)
    {
        var page = this.map.objId[id];
        if (page)
        {
            var name = page.getName();
            if (aAddress[name]) continue;

//            aAddress[name] = true;
            aAddress[name] = false;

            if (page.extension.length > 0) this.getRecursiveAddressArray(name, aAddress);
        }
        else
        {
            this.map.obj[address].extension.remove(id);
            this.setChangeType(this.ESSENTIAL_CHANGE);
        }
    }
}

yarip.resetOnAddress = function(obj)
{
    if (!obj) return false;

    var list = null;

    switch (obj.type)
    {
        case this.TYPE_WHITELIST:
            list = this.map.obj[obj.address] ? this.map.obj[obj.address].elementWhitelist : null;
            break;

        case this.TYPE_BLACKLIST:
            list = this.map.obj[obj.address] ? this.map.obj[obj.address].elementBlacklist : null;
            break;

        case this.TYPE_STYLE:
            list = this.map.obj[obj.address] ? this.map.obj[obj.address].styles : null;
            break;
    }

    var elements = this.getElementsByXPath(obj.document, obj.xValue);
    if (elements) for (var i = 0; i < elements.snapshotLength; i++)
    {
        var element = elements.snapshotItem(i);
        if (element.nodeType != 1) continue;

        switch (element.getAttribute("status"))
        {
            case "whitelisted":
            case "blacklisted":
            case "styled":
                element.removeAttribute("status");
        }
    }

    if (list)
    {
        list.remove(obj.xValue);
        this.setChangeType(this.ESSENTIAL_CHANGE);
    }
    delete this.undoObj[obj.type + "-" + obj.xValue];
    return true;
}

yarip.getIncrement = function(newIncrement, oldIncrement)
{
    return newIncrement > oldIncrement ? newIncrement : oldIncrement;
}

yarip.reloadPage = function(address)
{
    if (this.pageDialog && address) this.pageDialog.reloadPage(address);
}

yarip.removeAllExceptWhitelisted = function(doc, pageAddress)
{
    this.whitelistXpath(doc, pageAddress, "/html/head/descendant-or-self::*[not(@status='blacklisted')]"); // whitelist head and descendants
    this.blacklistXpath(doc, pageAddress, "//*[not(@status='whitelisted')]"); // remove all except whitelisted
}

yarip.whitelistXpath = function(doc, address, xValue, isNew, xpath, doIncrement)
{
    if (!doc || !address || !xValue) return false;

    var elements = this.getElementsByXPath(doc, xValue);
    if (!elements) return false;

    var elementWhitelist = this.map.obj[address] ? this.map.obj[address].elementWhitelist : null;
    var found = false;
    var increment = this.INCREMENT_NOT_FOUND;

    for (var i = 0; i < elements.snapshotLength; i++)
    {
        var element = elements.snapshotItem(i);

        switch (element.nodeType)
        {
            // ELEMENT
            case 1:
                switch (element.getAttribute("status"))
                {
                    case "whitelisted":
                    case "blacklisted":
//                        increment = this.INCREMENT_IGNORED;
                        increment = this.getIncrement(this.INCREMENT_IGNORED, increment);
                        continue;
                }

                if (isNew) element.setAttribute("status", "whitelisted");
                else
                {
                    while (element && element.nodeType == 1 && element.getAttribute("status") != "whitelisted")
                    {
                        element.setAttribute("status", "whitelisted");
//                        element.setAttribute("title", xValue);
                        element = element.parentNode;
                    }
                }
                break;

            default:
                continue;
        }

        increment = this.INCREMENT_FOUND;
        found = true;
    }

    if (doIncrement && elementWhitelist && elementWhitelist.obj[xValue])
    {
        switch (increment)
        {
            case this.INCREMENT_FOUND:
                elementWhitelist.obj[xValue].incrementFound();
                break;

            case this.INCREMENT_NOT_FOUND:
                elementWhitelist.obj[xValue].incrementNotFound();
                break;

            case this.INCREMENT_IGNORED:
                elementWhitelist.obj[xValue].incrementIgnored();
                break;
        }

        this.setChangeType(this.MINOR_CHANGE);
    }

    if (isNew && found)
    {
//        if (!this.map.obj[address]) this.map.add(new YaripPage(null, address));
        if (!this.map.obj[address]) this.map.add(new YaripPage(this.getId(), address));
//        var tmpXPath = xpath ? xpath : new YaripElement(xValue, this.deep);
        var tmpXPath = xpath ? xpath : new YaripElement(xValue);
        this.map.obj[address].elementWhitelist.add(tmpXPath);
        this.setChangeType(this.ESSENTIAL_CHANGE);
        var obj = {}
        obj.document = doc;
        obj.address = address;
        obj.xValue = xValue;
        obj.type = this.TYPE_WHITELIST;
        this.undoObj[obj.type + "-" + obj.xValue] = obj;

//        if (this.pageDialog) this.pageDialog.reloadPage(address);
        this.reloadPage(address);
    }

    return found;
}

yarip.blacklistXpath = function(doc, address, xValue, isNew, force, xpath, doIncrement)
{
    if (!doc || !address || !xValue) return false;

    var elements = this.getElementsByXPath(doc, xValue);
    if (!elements) return false;

    var elementBlacklist = this.map.obj[address] ? this.map.obj[address].elementBlacklist : null;
    var found = false;
    var increment = this.INCREMENT_NOT_FOUND;

    for (var i = 0; i < elements.snapshotLength; i++)
    {
        var element = elements.snapshotItem(i);

        switch (element.nodeType)
        {
            // ELEMENT
            case 1:
                switch (element.getAttribute("status"))
                {
                    case "whitelisted":
                    case "blacklisted":
                        if (!force)
                        {
//                            increment = this.INCREMENT_IGNORED;
                            increment = this.getIncrement(this.INCREMENT_IGNORED, increment);
                            continue;
                        }
                }

                switch (element.localName.toLowerCase())
                {
                    case "html":
                    case "body":
                    case "frameset":
                        continue;

                    case "head":
                        element.innerHTML =
                            "<style rel='stylesheet' type='text/css'>" +
                                "* {" +
                                    "margin: 0 !important;" +
                                    "padding: 0 !important;" +
                                "}" +
                                "div {" +
                                    "height: auto !important;" +
                                "}" +
                                "table {" +
                                    "border-spacing: 0 0 !important;" +
                                    "height: auto !important;" +
                                    "width: 0 !important;" +
                                "}" +
                            "</style>";
                        break;

                    case "script":
                        element.removeAttribute("src");
                        element.innerHTML = "";
                        break;

                    case "frame":
                        if (element.parentNode.localName == "FRAMESET") break;
                        element.setAttribute("src", "about:blank");
                        element.setAttribute("status", "blacklisted");
                        break;

                    case "embed":
                    case "iframe":
                        element.setAttribute("src", "about:blank");
                        element.setAttribute("status", "blacklisted");
                        break;

                    default:
                        element.setAttribute("status", "blacklisted");
                        if (this.purgeInnerHTML && !isNew) element.innerHTML = "";
                }
                break;

            // ATTRIBUTE
            case 2:
                if (element.ownerElement) element.ownerElement.removeAttribute(element.name);
                break;

            // TEXT
            case 3:
                if (element.parentNode) element.parentNode.removeChild(element);
                break;

            default:
                continue;
        }

        increment = this.INCREMENT_FOUND;
        found = true;
    }

    if (doIncrement && elementBlacklist && elementBlacklist.obj[xValue])
    {
        switch (increment)
        {
            case this.INCREMENT_FOUND:
                elementBlacklist.obj[xValue].incrementFound();
                break;

            case this.INCREMENT_NOT_FOUND:
                elementBlacklist.obj[xValue].incrementNotFound();
                break;

            case this.INCREMENT_IGNORED:
                elementBlacklist.obj[xValue].incrementIgnored();
                break;
        }

        this.setChangeType(this.MINOR_CHANGE);
    }

    if (isNew && found)
    {
//        if (!this.map.obj[address]) this.map.add(new YaripPage(null, address));
        if (!this.map.obj[address]) this.map.add(new YaripPage(this.getId(), address));
//        var tmpXPath = xpath ? xpath : new YaripElement(xValue, this.deep);
        var tmpXPath = xpath ? xpath : new YaripElement(xValue);
        tmpXPath.createStyle();
        this.map.obj[address].elementBlacklist.add(tmpXPath);
        this.setChangeType(this.ESSENTIAL_CHANGE);
        var obj = {}
        obj.document = doc;
        obj.address = address;
        obj.xValue = xValue;
        obj.type = this.TYPE_BLACKLIST;
        this.undoObj[obj.type + "-" + obj.xValue] = obj;

//        if (this.pageDialog) this.pageDialog.reloadPage(address);
        this.reloadPage(address);
    }

    return found;
}

yarip.whitelistContent = function(address, regExpValue, regexp)
{
    if (!address || !regExpValue) return false;

    if (!this.map.obj[address]) this.map.add(new YaripPage(this.getId(), address));
//    var tmpRegExp = regexp ? regexp : new YaripContent(null, regExpValue, this.deep);
    var tmpRegExp = regexp ? regexp : new YaripContent(null, regExpValue);
    this.map.obj[address].contentWhitelist.add(tmpRegExp);
    this.setChangeType(this.ESSENTIAL_CHANGE);

//    if (this.pageDialog) this.pageDialog.reloadPage(address);
    this.reloadPage(address);

    return true;
}

yarip.blacklistContent = function(address, regExpValue, regexp)
{
    if (!address || !regExpValue) return false;

    if (!this.map.obj[address]) this.map.add(new YaripPage(this.getId(), address));
//    var tmpRegExp = regexp ? regexp : new YaripContent(null, regExpValue, this.deep);
    var tmpRegExp = regexp ? regexp : new YaripContent(null, regExpValue);
    this.map.obj[address].contentBlacklist.add(tmpRegExp);
    this.setChangeType(this.ESSENTIAL_CHANGE);

//    if (this.pageDialog) this.pageDialog.reloadPage(address);
    this.reloadPage(address);

    return true;
}

//yarip.blacklistXpath = function(doc, address, xValue, isNew, force, xpath, doIncrement)
//yarip.style = function(doc, address, xValue, xStyle, isNew, doIncrement)
yarip.style = function(doc, address, xValue, xStyle, isNew, xpath, doIncrement)
{
    if (!doc || !address || !xValue || !xStyle) return false;

    var elements = this.getElementsByXPath(doc, xValue);
    if (!elements) return false;

    var styles = this.map.obj[address] ? this.map.obj[address].styles : null;
    var found = false;
    var increment = this.INCREMENT_NOT_FOUND;

    for (var i = 0; i < elements.snapshotLength; i++)
    {
        var element = elements.snapshotItem(i);

        switch (element.nodeType)
        {
            // ELEMENT
            case 1:
                var style = element.getAttribute("style");
                element.setAttribute("style", style ? style + xStyle : xStyle);
//                element.setAttribute("status", "styled");
                break;

            default:
                continue;
        }

        increment = this.INCREMENT_FOUND;
        found = true;
    }

    if (doIncrement && styles && styles.obj[xValue])
    {
        switch (increment)
        {
            case this.INCREMENT_FOUND:
                styles.obj[xValue].incrementFound();
                break;

            case this.INCREMENT_NOT_FOUND:
                styles.obj[xValue].incrementNotFound();
                break;
        }

        this.setChangeType(this.MINOR_CHANGE);
    }

    if (isNew && found)
    {
//        if (!this.map.obj[address]) this.map.add(new YaripPage(null, address));
        if (!this.map.obj[address]) this.map.add(new YaripPage(this.getId(), address));
//        var xpath = new YaripElement(xValue, this.deep, null, null, xStyle);
        var tmpXPath = xpath ? xpath : new YaripElement(xValue, null, null, null, xStyle);
        this.map.obj[address].styles.add(tmpXPath);
        this.setChangeType(this.ESSENTIAL_CHANGE);
        var obj = {}
        obj.document = doc;
        obj.address = address;
        obj.xValue = xValue;
        obj.type = this.TYPE_STYLE;
        this.undoObj[obj.type + "-" + obj.xValue] = obj;

//        if (this.pageDialog) this.pageDialog.reloadPage(address);
        this.reloadPage(address);
    }

    return found;
}

yarip.calculateXPath = function(element, fullPath)
{
    if (!element || !element.localName) return null;

    if (element.nodeType == 2) return this.calculateXPath(element.ownerElement, fullPath) + "/@" + element.localName.toLowerCase(); // attribute

    var xValue = "";
    do
    {
        var attributes = "";
        if (element.getAttribute("id"))
        {
            // ID
            attributes += "[@id='" + element.getAttribute("id") + "']";
            if (!fullPath) return "//" + element.localName.toLowerCase() + attributes + xValue; // shortest xpath
        }
        else
        {
            // ATTRIBUTES
            if (element.getAttribute("name")) attributes += "@name='" + element.getAttribute("name") + "' and ";
            if (element.getAttribute("class")) attributes += "@class='" + element.getAttribute("class") + "' and ";
            if (attributes != "") attributes = "[" + attributes.substring(0, attributes.length - 5) + "]";

            // INDEX
            if (!/^(html|head|title|body|thead|tbody|tfoot|frameset)$/i.test(element.localName))
            {
                var index = 1;
                var sibling = element.previousSibling;
                while (sibling)
                {
//                    if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) ++index;
                    if (sibling.localName == element.localName) ++index;
                    sibling = sibling.previousSibling;
                }

                var found = false;
                sibling = element.nextSibling;
                while (!found && sibling)
                {
//                    if (sibling.localName && element.localName && sibling.localName.toLowerCase() == element.localName.toLowerCase()) found = true;
                    if (sibling.localName == element.localName) found = true;
                    else sibling = sibling.nextSibling;
                }
                if (found || index > 1 || this.alwaysUseIndex) attributes = "[" + index + "]" + attributes;
            }
        }
        xValue = "/" + element.localName.toLowerCase() + attributes + xValue;

        element = element.parentNode;
    } while (element && element.nodeType == 1);

    return xValue != "" ? xValue : null;
}

yarip.getElementsByXPath = function(doc, xValue)
{
    var elements = null;
    try { elements = doc.evaluate(xValue, doc, null, Components.interfaces.nsIDOMXPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null); }
    catch (e)
    {
        var consoleService = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
        var scriptError = Components.classes['@mozilla.org/scripterror;1'].createInstance(Components.interfaces.nsIScriptError);
//        var message = doc.getElementById("yarip-overlay-stringbundle").getFormattedString("malformedXpath", [xValue]);
        var message = "[xpath=" + xValue + "] ";
//        var sourceName = "chrome://yarip/content/yarip.js";
        var sourceName = "";
        scriptError.init(message + e.message, sourceName, null, e.lineNumber, e.columnNumber, scriptError.errorFlag, "content javascript");
        consoleService.logMessage(scriptError);
    }
//    if (!elements || elements.snapshotLength == 0) return null;
    return elements;
}

yarip.generateRegExp = function(value)
{
    if (!value) return null;
//    return "^" + value.replace(/([/.*+?|()\[\]{}\\])/g, "\\$1") + "$";
    return "^" + value.replace(/([.*+?|()\[\]{}\\])/g, "\\$1") + "$";
}

yarip.checkXPath = function(xValue)
{
    if (!xValue) return false;
    try
    {
        var dp = Components.classes['@mozilla.org/xmlextras/domparser;1'].createInstance(Components.interfaces.nsIDOMParser);
        var doc = dp.parseFromString("<yarip></yarip>", "text/xml");
//        doc.evaluate(xValue, doc, null, Components.interfaces.nsIDOMXPathResult.ANY_TYPE, null);
        doc.evaluate(xValue, doc, null, Components.interfaces.nsIDOMXPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    }
    catch (e) { return false; }
    return true;
}

yarip.checkRegExp = function(reValue)
{
    if (!reValue) return false;
    try { new RegExp(reValue).test(""); }
    catch (e) { return false; }
    return true;
}

yarip.getElements = function(doc, xValue)
{
    var elements = null;
    try { elements = doc.evaluate(xValue, doc, null, Components.interfaces.nsIDOMXPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null); } catch (e) {}
    return elements;
}

yarip.highlight = function(doc, xValue)
{
    if (!doc || !xValue) return false;
    var elements = this.getElements(doc, xValue);
    if (elements && elements.snapshotLength > 0)
    {
        for (var i = 0; i < elements.snapshotLength; i++)
        {
            var element = elements.snapshotItem(i);
            if (element.getAttribute && !/\bhighlighted\b/.test(element.getAttribute("status"))) element.setAttribute("status", element.getAttribute("status") + " highlighted");
        }
        return true;
    }
    return false;
}

yarip.unHighlight = function(doc, xValue)
{
    if (!doc || !xValue) return;

    var elements = this.getElements(doc, xValue);
    if (elements && elements.snapshotLength > 0)
    {
        for (var i = 0; i < elements.snapshotLength; i++)
        {
            var element = elements.snapshotItem(i);
//            if (element.getAttribute && !/^whitelist|blacklist$/.test(element.getAttribute("status")))
//            if (element.getAttribute && element.getAttribute("status") != "blacklist")
            if (element.getAttribute && /\bhighlighted\b/.test(element.getAttribute("status")))
            {
//                element.removeAttribute("status");
                element.setAttribute("status", element.getAttribute("status").replace(/\s*highlighted/, ""));
            }
        }
    }
}

yarip.save = function()
{
    if (this.changeType == this.NO_CHANGE) return;

    // SAVE XPATHS
    var file = this.getFile(this.XPATH);
    this.map.sort(true);
    var data = this.map.generateXml();
    this.saveToFile(data, file);

    if (this.changeType == this.ESSENTIAL_CHANGE)
    {
        // SAVE STYLES
        file = this.getFile(this.STYLE);
        data = this.map.generateCSS();
        this.saveToFile(data, file);

        if (file)
        {
            var uri = "file://" + file.path;
            this.injectCSS(uri, false);
            this.injectCSS(uri, true);
        }
    }

    this.setChangeType(this.NO_CHANGE, true);
//    this.setValue(this.RELOAD, new Date().getTime(), this.STRING); // notify
}

yarip.getValue = function(preference, defaultValue, type)
{
    try
    {
        switch (type)
        {
            case this.BOOLEAN:
                return prefBranch.getBoolPref(preference);

            case this.INTEGER:
                return prefBranch.getIntPref(preference);

            case this.STRING:
                return prefBranch.getCharPref(preference);
        }
    }
    catch (e)
    {
        if (defaultValue != false && (typeof defaultValue != "number" || defaultValue + "" == "NaN") && !defaultValue) return null;
        this.setValue(preference, defaultValue, type);
    }

    return this.getValue(preference, null, type);
}

yarip.setValue = function(preference, value, type)
{
    try
    {
        switch (type)
        {
            case this.BOOLEAN:
                prefBranch.setBoolPref(preference, "" + value == "true");
                break;

            case this.INTEGER:
                prefBranch.setIntPref(preference, value);
                break;

            case this.STRING:
                prefBranch.setCharPref(preference, value);
                break;

            case this.RESET:
                prefBranch.clearUserPref(preference);
                break;
        }
    }
    catch (e){}
}

yarip.deleteBranch = function(branch)
{
    if (!branch) return;

    prefBranch.deleteBranch(branch);
}

yarip.injectCSS = function(uri, value)
{
    if (!uri) return;

    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var uri = ios.newURI(uri, this.CHARSET, null); // uri, charset, baseuri
    var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService);
    if (value) { if (!sss.sheetRegistered(uri, sss.USER_SHEET)) sss.loadAndRegisterSheet(uri, sss.USER_SHEET); }
    else { if (sss.sheetRegistered(uri, sss.USER_SHEET)) sss.unregisterSheet(uri, sss.USER_SHEET); }
}

yarip.getCurrentVersion = function()
{
    return Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getItemForID("yarip@mozdev.org").version;
}

//yarip.encode = function(value)
//{
//    if (!value) return "";

//    for (var ch in this.CHARACTERS) value = value.replace(this.CHARACTERS[ch], ch);
//    return value;
//}

yarip.check = function(file)
{
    // FIRST RUN
    var firstrun = this.getValue(this.FIRSTRUN, true, this.BOOLEAN);
    if (firstrun)
    {
        this.setValue(this.FIRSTRUN, false, this.BOOLEAN);
    }

    // UPGRADE
    var previous = this.getValue(this.VERSION, "", this.STRING);
    var current = this.getCurrentVersion();
    if (previous != current && !firstrun)
    {
        this.setValue(this.VERSION, current, this.STRING);

        if (/^0\.1\.[2-7]$/.test(previous) && !/^0\.1\.[2-7]$/.test(current))
        {
            // CREATED STYLES FOR XPATHS
            for (var p in this.map.obj) for (var x in this.map.obj[p].elementBlacklist.obj) this.map.obj[p].elementBlacklist.obj[x].createStyle(true);
            this.setChangeType(this.ESSENTIAL_CHANGE);
        }

        if (/^0\.(1\.[2-9]|2\.1)$/.test(previous) && !/^0\.(1\.[2-9]|2\.1)$/.test(current))
        {
            // CHANGED NOFLICKER FEATURE
            this.setValue("content.notify.ontimer", null, this.RESET);
            this.setValue("content.notify.backoffcount", null, this.RESET);
            this.setValue("nglayout.initialpaint.delay", null, this.RESET);
        }

        this.deleteBranch("extensions.yarip.changeType"); // >0.1.7
        this.deleteBranch("extensions.yarip.flickerType"); // >0.1.7
        this.deleteBranch("extensions.yarip.loggingEnabled"); // >0.2.1
        this.deleteBranch("extensions.yarip.deep"); // >0.2.2
        this.deleteBranch("extensions.yarip.profile"); // >0.2.2
        this.deleteBranch("extensions.yarip.reload"); // >0.2.2
    }
}

yarip.getId = function()
{
    var id = new Date().getTime();
    while (this.map.objId["" + id] != undefined && this.map.objId["" + id] != null) id++;
    return "" + id;
}

yarip.addMonitorDialog = function(monitorDialog)
{
    monitorDialog.id = new Date().getTime();
//    while (this.monitorDialog["" + monitorDialog.id] != undefined && this.monitorDialog["" + monitorDialog.id] != null) monitorDialog.id++;
    while (this.monitorDialog["" + monitorDialog.id] != undefined) monitorDialog.id++;
    this.monitorDialog["" + monitorDialog.id] = monitorDialog;
}

yarip.removeMonitorDialog = function(monitorDialog)
{
    delete this.monitorDialog["" + monitorDialog.id];
    monitorDialog.id = -1;
}

yarip.load = function(file, imported)
{
    var doc = this.getDoc(file);
    if (!doc)
    {
        if (!imported)
        {
            this.setChangeType(this.ESSENTIAL_CHANGE);
            this.save();
        }
        return null;
    }
    else if (doc.documentElement.nodeName == "parsererror") return null;

    var pageName = null;
    var map = new YaripMap();

    var iYarip = doc.evaluate("./yarip", doc, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
    var nYarip = iYarip.iterateNext();
    if (!nYarip) return null;

    var version = nYarip.getAttribute("version");
    if (!version)
    {
        var iPage = doc.evaluate("./yarip/page[child::whitelist or child::blacklist]", doc, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nPage = iPage.iterateNext();
        while (nPage)
        {
            pageName = nPage.getAttribute("name");
            var id = nPage.getAttribute("id");
            var page = map.obj[pageName] ? map.obj[pageName] : new YaripPage(id ? id : this.getId(), pageName);

            // XPATH WHITELIST
            var iXPathWhitelist = doc.evaluate("./whitelist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nXPathWhitelist = iXPathWhitelist.iterateNext();
            if (nXPathWhitelist)
            {
                var iXPath = doc.evaluate("./xpath", nXPathWhitelist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
                var nXPath = iXPath.iterateNext();
                while (nXPath)
                {
                    page.elementWhitelist.add(new YaripElement(
                        nXPath.getAttribute("value"),
                        nXPath.getAttribute("deep"),
                        null,
                        null,
                        null,
                        nXPath.getAttribute("found"),
                        nXPath.getAttribute("notFound"),
                        nXPath.getAttribute("whitelisted")));
                    nXPath = iXPath.iterateNext();
                }
            }

            // XPATH BLACKLIST
            var iXPathBlacklist = doc.evaluate("./blacklist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nXPathBlacklist = iXPathBlacklist.iterateNext();
            if (nXPathBlacklist)
            {
                var iXPath = doc.evaluate("./xpath", nXPathBlacklist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
                var nXPath = iXPath.iterateNext();
                while (nXPath)
                {
                    page.elementBlacklist.add(new YaripElement(
                        nXPath.getAttribute("value"),
                        nXPath.getAttribute("deep"),
                        nXPath.getAttribute("force") == "true",
                        nXPath.getAttribute("dependsOnWhitelist"),
                        nXPath.getAttribute("style"),
                        nXPath.getAttribute("found"),
                        nXPath.getAttribute("notFound"),
                        nXPath.getAttribute("whitelisted")));
                    nXPath = iXPath.iterateNext();
                }
            }

            map.add(page);
            nPage = iPage.iterateNext();
        }
    }
    else if (version == "0.2")
    {
        var iPage = doc.evaluate("./page", nYarip, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nPage = iPage.iterateNext();
        while (nPage)
        {
            pageName = nPage.getAttribute("name");
            var id = nPage.getAttribute("id");
            var page = map.obj[pageName] ? map.obj[pageName] : new YaripPage(id ? id : this.getId(), pageName);

            // ELEMENT BLACKLIST
            var iElementBlacklist = doc.evaluate("./elementBlacklist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nElementBlacklist = iElementBlacklist.iterateNext();
            if (nElementBlacklist)
            {
                var iElement = doc.evaluate("./element", nElementBlacklist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
                var nElement = iElement.iterateNext();
                while (nElement)
                {
                    var element = new YaripElement(
                        nElement.getAttribute("xpath"),
                        nElement.getAttribute("deep"),
                        nElement.getAttribute("force") == "true",
                        nElement.getAttribute("dow"),
                        nElement.getAttribute("style"),
                        nElement.getAttribute("found"),
                        nElement.getAttribute("notFound"),
                        nElement.getAttribute("ignored"));
                    if (imported) element.createStyle();
                    page.elementBlacklist.add(element);
                    nElement = iElement.iterateNext();
                }
            }

            // CONTENT BLACKLIST
            var iContentBlacklist = doc.evaluate("./contentBlacklist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nContentBlacklist = iContentBlacklist.iterateNext();
            if (nContentBlacklist)
            {
                var iContent = doc.evaluate("./content", nContentBlacklist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
                var nContentBlacklist = iContent.iterateNext();
                while (nContentBlacklist)
                {
                    page.contentBlacklist.add(new YaripContent(
                        nContentBlacklist.getAttribute("type"),
                        nContentBlacklist.getAttribute("regexp"),
                        nContentBlacklist.getAttribute("deep"),
                        nContentBlacklist.getAttribute("force") == "true",
                        nContentBlacklist.getAttribute("found"),
                        nContentBlacklist.getAttribute("ignored")));
                    nContentBlacklist = iContent.iterateNext();
                }
            }

            map.add(page);
            nPage = iPage.iterateNext();
        }
    }

    var iPage = doc.evaluate("./page", nYarip, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
    var nPage = iPage.iterateNext();
    while (nPage)
    {
        pageName = nPage.getAttribute("name");
        var id = nPage.getAttribute("id");
        var page = map.obj[pageName] ? map.obj[pageName] : new YaripPage(id ? id : this.getId(), pageName);

        // ELEMENT WHITELIST
        var iElementWhitelist = doc.evaluate("./elementWhitelist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nElementWhitelist = iElementWhitelist.iterateNext();
        if (nElementWhitelist)
        {
            page.elementWhitelist.setExclusive(nElementWhitelist.getAttribute("exclusive"));
            var iElement = doc.evaluate("./element", nElementWhitelist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nElement = iElement.iterateNext();
            while (nElement)
            {
                page.elementWhitelist.add(new YaripElement(
                    nElement.getAttribute("xpath"),
                    nElement.getAttribute("deep"),
                    null,
                    null,
                    null,
                    nElement.getAttribute("found"),
                    nElement.getAttribute("notFound"),
                    nElement.getAttribute("ignored")));
                nElement = iElement.iterateNext();
            }
        }

        // ELEMENT BLACKLIST
        var iElementBlacklist = doc.evaluate("./elementBlacklist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nElementBlacklist = iElementBlacklist.iterateNext();
        if (nElementBlacklist)
        {
            var iElement = doc.evaluate("./element", nElementBlacklist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nElement = iElement.iterateNext();
            while (nElement)
            {
                var element = new YaripElement(
                    nElement.getAttribute("xpath"),
                    nElement.getAttribute("deep"),
                    nElement.getAttribute("force"),
                    nElement.getAttribute("dow"),
                    nElement.getAttribute("style"),
                    nElement.getAttribute("found"),
                    nElement.getAttribute("notFound"),
                    nElement.getAttribute("ignored"));
                if (imported) element.createStyle();
                page.elementBlacklist.add(element);
                nElement = iElement.iterateNext();
            }
        }

        // CONTENT WHITELIST
        var iContentWhitelist = doc.evaluate("./contentWhitelist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nContentWhitelist = iContentWhitelist.iterateNext();
        if (nContentWhitelist)
        {
            page.contentWhitelist.setExclusive(nContentWhitelist.getAttribute("exclusive"));
            var iContent = doc.evaluate("./content", nContentWhitelist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nContentWhitelist = iContent.iterateNext();
            while (nContentWhitelist)
            {
                page.contentWhitelist.add(new YaripContent(
                    nContentWhitelist.getAttribute("type"),
                    nContentWhitelist.getAttribute("regexp"),
                    nContentWhitelist.getAttribute("deep"),
                    null,
                    nContentWhitelist.getAttribute("found")));
                nContentWhitelist = iContent.iterateNext();
            }
        }

        // CONTENT BLACKLIST
        var iContentBlacklist = doc.evaluate("./contentBlacklist", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nContentBlacklist = iContentBlacklist.iterateNext();
        if (nContentBlacklist)
        {
            var iContent = doc.evaluate("./content", nContentBlacklist, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nContentBlacklist = iContent.iterateNext();
            while (nContentBlacklist)
            {
                page.contentBlacklist.add(new YaripContent(
                    nContentBlacklist.getAttribute("type"),
                    nContentBlacklist.getAttribute("regexp"),
                    nContentBlacklist.getAttribute("deep"),
                    nContentBlacklist.getAttribute("force"),
                    nContentBlacklist.getAttribute("found"),
                    nContentBlacklist.getAttribute("ignored")));
                nContentBlacklist = iContent.iterateNext();
            }
        }

        // STYLES
        var iStyles = doc.evaluate("./styles", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nStyles = iStyles.iterateNext();
        if (nStyles)
        {
            var iXPath = doc.evaluate("./element", nStyles, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nXPath = iXPath.iterateNext();
            while (nXPath)
            {
                page.styles.add(new YaripElement(
                    nXPath.getAttribute("xpath"),
                    nXPath.getAttribute("deep"),
                    null,
                    null,
                    nXPath.getAttribute("style"),
                    nXPath.getAttribute("found"),
                    nXPath.getAttribute("notFound")));
                nXPath = iXPath.iterateNext();
            }
        }

        // EXTENSION
        var iExtension = doc.evaluate("./extension", nPage, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
        var nExtension = iExtension.iterateNext();
        if (nExtension)
        {
            var iXPath = doc.evaluate("./item", nExtension, null, Components.interfaces.nsIDOMXPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
            var nXPath = iXPath.iterateNext();
            while (nXPath)
            {
                page.extension.add(new YaripItem(nXPath.getAttribute("value")));
                nXPath = iXPath.iterateNext();
            }
        }

        map.add(page);
        nPage = iPage.iterateNext();
    }

    if (!imported) this.map = map;
    else this.map.merge(map);

    return pageName;
}

yarip.getDoc = function(file)
{
    if (!file) return null;

    var data = this.getData(file);
    if (!data || data == "") return null;

    var dp = Components.classes['@mozilla.org/xmlextras/domparser;1'].createInstance(Components.interfaces.nsIDOMParser);
    return dp.parseFromString(data, "text/xml");
}

yarip.getData = function(file)
{
    if (!file) return "";

    var fis = null;
    var sis = null;
    var data = null;
    try {
        fis = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
        fis.init(file, 0x01, 00004, null);
        sis = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
        sis.init(fis);
        data = sis.read(sis.available());
        var suc = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        suc.charset = this.CHARSET;
        var data = suc.ConvertToUnicode(data);
    } catch (e) {
    } finally {
        if (sis != null) try { sis.close(); } catch (e) {}
        if (fis != null) try { fis.close(); } catch (e) {}
    }
    return data ? data : "";
}

yarip.getFile = function(path)
{
    if (!path) return null;
    var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
    var aPath = path.split(/\/|\\/);
    for (var i = 0; i < aPath.length; i++) file.append(aPath[i]);
    if (!file.exists()) file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0600);
    if (file.isFile()) return file;
    else return null;
}

yarip.saveToFile = function(data, file)
{
    if (data != "" && !data || !file) return;

    var fos = null;
    var os = null;
    try {
        fos = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
        fos.init(file, 0x02 | 0x08 | 0x20, 0600, 0);
//        fos.write(data, data.length);

        os = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
        os.init(fos, this.CHARSET, 0, 0x0000);
        os.writeString(data);
    } catch (e) {
    } finally {
        if (fos != null) try { fos.close(); } catch (e) {}
        if (os != null) try { os.close(); } catch (e) {}
    }
}

yarip.QueryInterface = function(aIID)
{
    if (Components.interfaces.nsISupports.equals(aIID)) return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
}

yarip.shouldLoad = function(contentType, contentLocation, requestOrigin, context, mimeTypeGuess, extra)
{
    if (!this.enabled || contentType == TYPE_DOCUMENT
        || !/^https?$/.test(contentLocation.scheme)
        || !/^https?$/.test(requestOrigin.scheme)) return ACCEPT;
//        || !context || !contentLocation || !requestOrigin
//        || /^(about|chrome|data|file|moz-icon|resource)$/.test(contentLocation.scheme)
//        || /^(about|chrome|data|file|moz-icon|resource)$/.test(requestOrigin.scheme)) return ACCEPT;

    var defaultView = null;
    if (context.nodeType != DOCUMENT_NODE) context = context.ownerDocument;
    if (context && context.nodeType == DOCUMENT_NODE) defaultView = context.defaultView;
    if (!defaultView) return ACCEPT;

//    var itemType = defaultView.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation).QueryInterface(Components.interfaces.nsIDocShellTreeItem).itemType;
//    if (itemType != Components.interfaces.nsIDocShellTreeItem.typeContent) return ACCEPT;

    var doc = defaultView.document;
    if (!doc) return ACCEPT;

    var pageAddress = this.getAddress(doc.location, this.PAGE_MODE);
    if (!pageAddress) return ACCEPT;

//    var aAddress = this.getAddressArray(doc, true);
    var aAddress = this.getAddressArray(pageAddress, true);
    switch (this.shouldBlacklistContent(pageAddress, aAddress, /*contentType,*/ contentLocation.spec, defaultView))
    {
        case 0:
//            if (this.monitorDialog) this.monitorDialog.logContent(0, doc.location, this.mode, contentLocation.spec);
            for (var id in this.monitorDialog) this.monitorDialog[id].logContent(0, doc.location, this.mode, contentLocation.spec);
            return ACCEPT;
        case 1:
//            if (this.monitorDialog) this.monitorDialog.logContent(1, doc.location, this.mode, contentLocation.spec);
            for (var id in this.monitorDialog) this.monitorDialog[id].logContent(1, doc.location, this.mode, contentLocation.spec);
            return ACCEPT;
        case 2:
//            if (this.monitorDialog) this.monitorDialog.logContent(2, doc.location, this.mode, contentLocation.spec);
            for (var id in this.monitorDialog) this.monitorDialog[id].logContent(2, doc.location, this.mode, contentLocation.spec);
            return REJECT_SERVER;
        default:
//            if (this.monitorDialog) this.monitorDialog.logContent(0, doc.location, this.mode, contentLocation.spec);
            for (var id in this.monitorDialog) this.monitorDialog[id].logContent(0, doc.location, this.mode, contentLocation.spec);
            return ACCEPT;
    }
}

yarip.shouldBlacklistContent = function(pageAddress, aAddress, /*contentType,*/ url, defaultView)
{
//    if (!aAddress || !url) return false;

    var whitelisted = false;
    var exclusive = false;
    var result = 0;

    for (var a in aAddress)
    {
        var contentWhitelist = this.map.obj[a].contentWhitelist;
        exclusive = exclusive || contentWhitelist.getExclusive();
        if (whitelisted) break;
//        if (!whitelisted && contentWhitelist.length > 0)
        if (contentWhitelist.length > 0)
        {
            var list = contentWhitelist.obj;
            var equalAddresses = this.equalAddresses(pageAddress, a);
            for (var k in list)
            {
                var content = list[k];

//                if (!content.getDeep() && !this.equalAddresses(pageAddress, a)) continue;
                if (!content.getDeep() && !equalAddresses) continue;
//                if (contentType != content.getType() && content.getType() != 0) continue;
//                if (contentType != content.getTypeIndex() && content.getTypeIndex() != 0) continue;
                if (content.getRegExpObj().test(url))
                {
//                    if (aAddress[a]) content.incrementFound();
                    content.incrementFound();
                    this.setChangeType(this.MINOR_CHANGE);
                    defaultView.yaripStatus = "found";
                    whitelisted = true;
                    result = 1;
                    break;
                }
            }
        }
//        exclusive = exclusive || contentWhitelist.getExclusive();
//        if (whitelisted) break;
    }

    for (var a in aAddress)
    {
        var contentBlacklist = this.map.obj[a].contentBlacklist;
        if (contentBlacklist.length > 0)
        {
            var list = contentBlacklist.obj;
            var equalAddresses = this.equalAddresses(pageAddress, a);
            for (var k in list)
            {
                var content = list[k];
//                if (!content.getDeep() && !this.equalAddresses(pageAddress, a)) continue;
                if (!content.getDeep() && !equalAddresses) continue;
//                if (contentType != content.getType() && content.getType() != 0) continue;
//                if (contentType != content.getTypeIndex() && content.getTypeIndex() != 0) continue;
                if (content.getRegExpObj().test(url))
                {
                    if (whitelisted && !content.getForce())
                    {
//                        if (aAddress[a]) content.incrementIgnored();
                        content.incrementIgnored();
                        continue;
                    }

//                    if (aAddress[a]) content.incrementFound();
                    content.incrementFound();
                    this.setChangeType(this.MINOR_CHANGE);
                    defaultView.yaripStatus = "found";
//                    return true;
                    return 2;
                }
            }
        }
    }

//    return !whitelisted && exclusive;
    return !whitelisted && exclusive ? 2 : result;
}

yarip.equalAddresses = function(pageAddress, address)
{
    if (pageAddress.indexOf(address) == -1) return true; // ignore deep (extension)
    pageAddress = pageAddress.replace(/\/+$/, "");
    address = address.replace(/\/+$/, "");
    if (this.noSchemeRegExp.test(address)) pageAddress = pageAddress.replace(/^[^:/?#]+:\/{2}/, ""); // remove scheme
    return pageAddress == address;
}

yarip.shouldProcess = function(contentType, contentLocation, requestOrigin, context, mimeType, extra)
{
    return ACCEPT;
}

yarip.QueryInterface = function(aIID)
{
    if (Components.interfaces.nsIContentPolicy.equals(aIID) || Components.interfaces.nsISupports.equals(aIID)) return this;
    throw Components.results.NS_ERROR_NO_INTERFACE;
}

yarip.wrappedJSObject = yarip;

var factory = {
    createInstance: function (aOuter, aIID)
    {
        if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION;

        var ssl = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
        ssl.loadSubScript("chrome://yarip/content/map.js");
        ssl.loadSubScript("chrome://yarip/content/page.js");
        ssl.loadSubScript("chrome://yarip/content/list.js");
        ssl.loadSubScript("chrome://yarip/content/xpath.js");

        yarip.map = new YaripMap();

//        yarip.logFile = yarip.getFile(yarip.LOG);
        yarip.saveToFile("", yarip.logFile); // purge

//        var file = yarip.getFile(yarip.XPATH);
//        yarip.load(file);
//        yarip.check(file);

        yarip.toggleEnabled(yarip.getValue(yarip.ENABLED, true, yarip.BOOLEAN));
//        yarip.setMode(yarip.FQDN_MODE);
        yarip.setMode(yarip.getValue(yarip.MODE, yarip.FQDN_MODE, yarip.INTEGER));
        yarip.setAlwaysUseIndex(yarip.getValue(yarip.INDEX, false, yarip.BOOLEAN));
        yarip.setElementsInContext(yarip.getValue(yarip.ELEMENTS, 4, yarip.INTEGER));
        yarip.setPurgeInnerHTML(yarip.getValue(yarip.PURGE, false, yarip.BOOLEAN));

        return yarip.QueryInterface(aIID);
    },

    QueryInterface: function (aIID)
    {
        if (Components.interfaces.nsIFactory.equals(aIID) || Components.interfaces.nsISupports.equals(aIID)) return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    }
}

var module = {
    registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
    {
        var cr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        cr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);

        var cm = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
        cm.deleteCategoryEntry("content-policy", CONTRACT_ID, true);
        cm.addCategoryEntry("content-policy", CONTRACT_ID, CONTRACT_ID, true, true);
    },

    unregisterSelf: function(aCompMgr, aLocation, aType)
    {
        var cr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        cr.unregisterFactoryLocation(CLASS_ID, aLocation);

        var cm = Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager);
        cm.deleteCategoryEntry("content-policy", CONTRACT_ID, true);
    },

    getClassObject: function(aCompMgr, aCID, aIID)
    {
        if (!Components.interfaces.nsIFactory.equals(aIID)) throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        if (CLASS_ID.equals(aCID)) return factory;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    canUnload: function(aCompMgr) { return true; }
}

function NSGetModule(aCompMgr, aFileSpec) { return module; }
