
/*
Copyright 2007-2009 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of yarip.

Yarip is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Yarip is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with yarip; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function YaripContentWhitelistDialog()
{

    this.location = null;
    this.obj = null;
    this.regExp = null;

    this.setRegExp = function(value)
    {
        if (!this.obj) return;

        this.regExp = value;
    }

    this.setDeep = function(value)
    {
        if (!this.obj) return;

        this.obj.content.setDeep(value);
    }

    this.load = function()
    {
        if (!"arguments" in window || window.arguments.length < 2) return;

        this.location = window.arguments[0];
        this.obj = window.arguments[1];
        if (!this.location || !this.obj) return;

        this.stringbundle = document.getElementById("contentWhitelist-dialog-stringbundle");
        document.getElementById("regexp").value = this.obj.content.getRegExp();
        document.getElementById("regexp").focus();
        document.getElementById("regexp").select();
        document.getElementById("page").value = this.obj.pageAddress;

        var menupopup = document.getElementById("page-menupopup");
        var menuitem = null;
        var address = yarip.getAddress(this.location, yarip.PAGE_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }

        address = yarip.getAddress(this.location, yarip.FQDN_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }

        address = yarip.getAddress(this.location, yarip.SLD_MODE);
        if (address)
        {
            menuitem = document.createElement("menuitem");
            menuitem.setAttribute("label", address);
            menuitem.setAttribute("value", address);
            menupopup.appendChild(menuitem);
        }
    }

    this.accept = function()
    {
        if (!this.obj) return;

        this.obj.pageAddress = document.getElementById("page").value;

        try
        {
            new RegExp(this.regExp).test("");
            this.obj.content.setRegExp(this.regExp);
        }
        catch (e)
        {
            var msg = this.stringbundle.getString("ERR_INVALID_REGEXP");
            alert(msg);
            throw new YaripException(msg);
        }

        var fh = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2);
        fh.addEntry("regexp", this.regExp);

        return;
    }

    this.cancel = function()
    {
        if (this.obj) this.obj.content = null;
    }
}
